Attribute VB_Name = "basParam"
Option Explicit

' p[^L[
Public Const csHistory          As String = "History"
Public Const csHistNum          As String = "HistNum"
Public Const csHistString       As String = "HistString"
Public Const csRestString       As String = "RestString"

Public Const csFontName         As String = "FontName"
Public Const csFontSize         As String = "FontSize"
Public Const csFontColor        As String = "FontColor"

' ftHgl
Public Const clDefHistNum       As Long = 6
Private Const csDefFontName     As String = "lr oSVbN"
Private Const clDefFontSize     As Long = 24
Private Const csDefFontColor    As String = "000000000"

' o[
Private mbHistory           As Boolean      ' \I^It
Private mlHistNum           As Long         ' iʁjۑ
Private msHistString()      As String       ' e
Private msRestString()      As String       ' ʓe

Private msFontName          As String       ' tHg
Private mlFontSize          As Long         ' tHgTCY
Private msFontColor         As String       ' tHgF

Public Property Get ncParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long) As Variant
'---------------------------------------------------------------------------
'    : ncParamValue()
' @@@\ : p[^l̎擾
' @@ : (I) psParamKey     p[^L[
'   l : p[^l
' @@ : 2002/07/03
'---------------------------------------------------------------------------
    Select Case psParamKey
    Case csHistory
        ncParamValue = mbHistory
    Case csHistNum
        ncParamValue = mlHistNum
    Case csHistString
        ncParamValue = msHistString(plIndex)
    Case csRestString
        ncParamValue = msRestString(plIndex)

    Case csFontName
        ncParamValue = msFontName
    Case csFontSize
        ncParamValue = mlFontSize
    Case csFontColor
        ncParamValue = msFontColor

    End Select
End Property

Public Property Let ncParamValue(ByVal psParamKey As String, Optional ByVal plIndex As Long, ByVal pvParamValue As Variant)
'---------------------------------------------------------------------------
'    : ncParamValue()
' @@@\ : p[^l̐ݒ
' @@ : (I) psParamKey     p[^L[
'          : (I) pvParamValue   p[^l
'   l : Ȃ
' @@ : 2002/07/03
'---------------------------------------------------------------------------
    Dim llLoopCnt           As Long         ' [vJE^
    Dim llNewCnt            As Long         ' Vf[^
    Dim lsHistString()      As String       ' 
    Dim lsRestString()      As String       ' 
    Dim lsKeyStr            As String       ' p[^L[
    Dim liEqlPos            As Integer      ' ̈ʒu
    Dim lsPrmStr            As String       ' p[^l

    Select Case psParamKey
    Case csHistory
        mbHistory = pvParamValue
    Case csHistNum
        mlHistNum = pvParamValue
    Case csHistString
        ReDim lsHistString(mlHistNum)
        ReDim lsRestString(mlHistNum)
        liEqlPos = InStr(pvParamValue, ",")
        lsKeyStr = Left$(pvParamValue, liEqlPos - 1)
        lsPrmStr = Mid$(pvParamValue, liEqlPos + 1)

        For llLoopCnt = 1 To mlHistNum
            If lsKeyStr <> msHistString(llLoopCnt) Then
                llNewCnt = llNewCnt + 1
                lsHistString(llNewCnt) = msHistString(llLoopCnt)
                lsRestString(llNewCnt) = msRestString(llLoopCnt)
            End If
        Next llLoopCnt
        If llNewCnt > mlHistNum - 1 Then
            llNewCnt = mlHistNum - 1
        End If
        msHistString(1) = lsKeyStr
        msRestString(1) = lsPrmStr
        For llLoopCnt = 1 To llNewCnt
            msHistString(llLoopCnt + 1) = lsHistString(llLoopCnt)
            msRestString(llLoopCnt + 1) = lsRestString(llLoopCnt)
        Next llLoopCnt
        Erase lsHistString
        Erase lsRestString

    Case csFontName
        msFontName = pvParamValue
    Case csFontSize
        mlFontSize = pvParamValue
    Case csFontColor
        msFontColor = pvParamValue

    End Select
End Property

Public Function ncReadIniFile() As Boolean
'---------------------------------------------------------------------------
'    : ncReadIniFile()
' @@@\ : p[^t@Cǂݍ
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/07/03
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsAppPath       As String           ' AvP[ṼpX
    Dim lsFileName      As String           ' t@C
    Dim lsLine          As String           ' ǂݍݕ
    Dim lsKeyStr        As String           ' p[^L[
    Dim liEqlPos        As Integer          ' ̈ʒu
    Dim lsPrmStr        As String           ' p[^l
    Dim llHistNum       As Long             ' i[ʒu

    On Error GoTo ncReadIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsFileName = lsAppPath & App.ProductName & ".ini"
    Else
        lsFileName = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    mbHistory = True
    mlHistNum = clDefHistNum
    ReDim Preserve msHistString(mlHistNum)
    ReDim Preserve msRestString(mlHistNum)
    msHistString(1) = "ƔŘIg"
    msRestString(1) = "o"

    msFontName = csDefFontName
    mlFontSize = clDefFontSize
    msFontColor = csDefFontColor

    Open lsFileName For Input Access Read As liFileNo
    On Error Resume Next
    Do While Not EOF(liFileNo)
        Line Input #liFileNo, lsLine
        lsLine = LTrim(lsLine)
        liEqlPos = InStr(lsLine, "=")

        If liEqlPos > 0 Then
            lsKeyStr = Left$(lsLine, liEqlPos - 1)
            lsPrmStr = Mid$(lsLine, liEqlPos + 1)

            Select Case UCase(Trim(lsKeyStr))
            Case UCase(csHistory)
                mbHistory = CBool(lsPrmStr)

            Case UCase(csHistNum)
                mlHistNum = Abs(CLng(lsPrmStr))
                ReDim Preserve msHistString(mlHistNum)
                ReDim Preserve msRestString(mlHistNum)

            Case UCase(csHistString)
                llHistNum = llHistNum + 1
                If llHistNum <= mlHistNum Then
                    liEqlPos = InStr(lsPrmStr, ",")
                    If liEqlPos > 0 Then
                        lsKeyStr = Left$(lsPrmStr, liEqlPos - 1)
                        lsPrmStr = Mid$(lsPrmStr, liEqlPos + 1)
                        msHistString(llHistNum) = Left(Trim(lsKeyStr), 6)
                        msRestString(llHistNum) = Left(Trim(lsPrmStr), 1)
                    Else
                        llHistNum = llHistNum - 1
                    End If
                End If

            Case UCase(csFontName)
                msFontName = Trim(lsPrmStr)

            Case UCase(csFontSize)
                mlFontSize = CInt(lsPrmStr)
                If mlFontSize < 1 Or mlFontSize > 99 Then
                    mlFontSize = clDefFontSize
                End If

            Case UCase(csFontColor)
                If Len(Trim(lsPrmStr)) = 9 Then
                    msFontColor = Trim(lsPrmStr)
                End If

            End Select
        End If
    Loop

    Close liFileNo
    ncReadIniFile = True
    Exit Function

ncReadIniFile_Error:
    Close liFileNo
    ncReadIniFile = False
End Function

Public Function ncWriteIniFile() As Boolean
'---------------------------------------------------------------------------
'    : ncWriteIniFile()
' @@@\ : ݒt@C̏
' @@ : Ȃ
'   l : True= , False= s
' @@ : 2002/07/03
'---------------------------------------------------------------------------
    Dim liFileNo        As Integer          ' t@Cԍ
    Dim lsIniFile       As String           ' ݒt@C
    Dim liRetCode       As Integer          ' ߂l
    Dim llLoopCnt       As Long             ' [vJE^
    Dim lsAppPath       As String           ' AvP[ṼpX

    On Error GoTo ncWriteIniFile_Error

    lsAppPath = App.Path
    If Right(lsAppPath, 1) = "\" Then
        lsIniFile = lsAppPath & App.ProductName & ".ini"
    Else
        lsIniFile = lsAppPath & "\" & App.ProductName & ".ini"
    End If
    liFileNo = FreeFile

    Open lsIniFile For Output Access Write As liFileNo
    Print #liFileNo, "[" & App.ProductName & "]"
    Print #liFileNo, ""

    If mbHistory = False Then
        Print #liFileNo, csHistory & "=" & mbHistory
    End If
    Print #liFileNo, csHistNum & "=" & mlHistNum
    For llLoopCnt = 1 To mlHistNum
        If msHistString(llLoopCnt) <> "" Then
            Print #liFileNo, csHistString & "=" & msHistString(llLoopCnt) & "," & msRestString(llLoopCnt)
        End If
    Next llLoopCnt

    If msFontName <> csDefFontName Then
        Print #liFileNo, csFontName & "=" & msFontName
    End If
    If mlFontSize <> clDefFontSize Then
        Print #liFileNo, csFontSize & "=" & mlFontSize
    End If
    If msFontColor <> csDefFontColor Then
        Print #liFileNo, csFontColor & "=" & msFontColor
    End If

    Close liFileNo
    ncWriteIniFile = True
    Exit Function

ncWriteIniFile_Error:
    liRetCode = MsgBox("ݒt@C݂̏Ɏs܂B" & vbCrLf & lsIniFile, vbCritical Or vbRetryCancel, "G[")
    If liRetCode = vbRetry Then
        Resume
    End If
    Close #liFileNo
    ncWriteIniFile = False
End Function
